<?php
//-----------------------------------------------------------------------------
// Пример выдачи поощрений за голосование на MinecraftRating.ru.
// Вся информация, высылаемая мониторингом находится в массиве $_POST
// и содержит следующие поля:
//
//		$_POST['username']		Имя пользователя, проголосовавшего за проект
//
//		$_POST['ip']			IP адрес проголосовавшего
//
//		$_POST['timestamp']		Время голосования в UNIX-формате
//
//		$_POST['signature']		SHA для проверки, пришел ли запрос от сайта
//								MinecraftRating.ru. Метод формирования
//								и использования указан ниже в коде.
// 
// 
//
// Шаблон для вашего скрипта выдачи поощрений.
// Для корректного отображения ошибок на сайте мониторинга
// Рекомендуется оставить файл в кодировке UTF8 (без BOM).
//
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
// Конфигурация
//-----------------------------------------------------------------------------
define ('SECRET_KEY',	'ВАШ СЕКРЕТНЫЙ КЛЮЧ');		// Используйте ключ со страницы http://minecraftrating.ru/promotion.html,
										// предварительно авторизовавшись на сайте
//-----------------------------------------------------------------------------
define ('DB_HOSTNAME', 	'localhost');	// Хост базы данных MySQL
define ('DB_USERNAME', 	'root');		// Пользователь базы данных MySQL 
define ('DB_PASSWORD', 	'123123');		// Пароль пользователя MySQL
define ('DB_DATABASE', 	'samplecraft');	// Название базы данных MySQL
//-----------------------------------------------------------------------------


//-----------------------------------------------------------------------------
// Вспомогательные функции
//-----------------------------------------------------------------------------
function post($key) {return isset($_POST[$key]) ? $_POST[$key]: NULL;}
//-----------------------------------------------------------------------------
function error($string)
{
	// Если вы будете посылать статус ошибки перед завершением скрипта,
	// умный мониторинг поймет, что у вас проблемы и известит вас об этом
	header($_SERVER['SERVER_PROTOCOL'] . ' 500 Server Error', TRUE, 500);

	// Завершает скрипт
	die(htmlspecialchars("site_error\n" . $string));
}
//-----------------------------------------------------------------------------



//-----------------------------------------------------------------------------
// Получаем данные из $_POST в соответствующие переменные и убеждаемся,
// что все данные пришли не пустыми.
//-----------------------------------------------------------------------------

$username	= $_POST['username'];
$ip		  	= $_POST['ip'];
$timestamp	= $_POST['timestamp'];
$signature	= $_POST['signature'];

// Убедимся, что прислали все нужные значения
if ( ! $username || ! $ip || ! $timestamp || ! $signature)
{
	error('Присланы не все данные, вероятно запрос подделан');
}


//-----------------------------------------------------------------------------
// Проверка подписи. С помощью этого небольшого кода вы можете убедиться, что
// запрос пришел именно с мониторинга MinecraftRating.ru. Этот кусок кода 
// не является обязательным и может быть удален не нарушая работы скрипта.
//-----------------------------------------------------------------------------

// Именно в такой последовательности мы собираем для вас подпись.
// Вы, зная свой SECRET KEY (его можно указать в личном кабинете),
// можете также собрать хеш из полученных данных и сравнить результат.
// Злоумышленник не сможет собрать такую подпись, не зная SECRET KEY.
$check_signature = sha1($username.$timestamp.SECRET_KEY);
// Пришла неправильная сигнатура
if ($check_signature != $signature)
{
	error('Неверная подпись / секретный ключ');
}

// Теперь мы убеждены, что запрос отправил MinecraftRating,
// и можем делать дорогостоящие операции.
//-----------------------------------------------------------------------------


// Подключаемся к базе MySQL
if ( ! $connection = mysql_connect(DB_HOSTNAME, DB_USERNAME, DB_PASSWORD))
{
	error('Не могу подключиться к базе данных');
}

// Выбираем базу данных
if ( ! mysql_select_db(DB_DATABASE))
{
	error('Не могу выбрать базу данных');
}


// На всякий случай экранируем спец.символы в имени игрока
$username = mysql_real_escape_string($username);

// Составляем запрос в базу данных.
// Вы можете изменить только этот запрос чтобы 
// подстроить скрипт под ваш проект.



// Пример запроса для плагина REDEEM (дадим предмет с ID 1)
$query = "INSERT INTO `redeem` (`player`, `item`) VALUES('$username', 1)";

// Пример запроса для плагина iconomy (даем 100 монет)
$query = "UPDATE `iconomy` SET `balance`=`balance`+100 WHERE `username`='$username'";



// Выполняем запрос
if ( ! mysql_query($query))
{
	error('Ошибка базы данных:' . mysql_error());
}

// Закрываем соединение с базой
mysql_close($connection);


// Этот ответ мониторинг будет воспринимать как
// полностью успешное завершение передачи данных.
// Рекомендуется оставить эту строку.
echo 'ok';


?>